display.setStatusBar( display.HiddenStatusBar )	-- HIDE STATUS BAR
local screenW = display.contentWidth
local screenH = display.contentHeight

-- LOAD THE LIBRARY
TextCandy = require("../lib_text_candy")

-- LOAD CHARSETS WE WANT TO USE
TextCandy.AddCharset 	("SMALL" , "Images/Small4_Gold", "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'*@():,$.!-%+?;#/_", 16, -5, -4)
TextCandy.AddCharset 	("SMALL2", "Images/Small3_White", "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'*@():,$.!-%+?;#/_", 16, -7, -4)
TextCandy.AddCharset 	("SPACE" , "Images/Space_Big_Orange", "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'*@():,$.!-%+?;#/_", 32, -5, -4)
TextCandy.AddCharset 	("SMOKY" , "Images/SmokyGlass_Medium_Gold", "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'*@():,$.!-%+?;#/_", 20, -8, -6)
TextCandy.AddCharset 	("FUR"   , "Images/ChiselWood2_Big", "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'*@():,$.!-%+?;#/_", 16, -10, -10)
TextCandy.AddCharset 	("LED"   , "Images/LED_Big_Orange", "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'*@():,$.!-%+?;#/_", 32, -10, -10)
TextCandy.AddCharset 	("GLOSSY","Images/Glossy_Big", "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'*@():,$.!-%+?;#/_", 32, -10, -10)
TextCandy.AddVectorFont ("Floraless", "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'*@():,$.!-%+?;#/_", 32, -2, -20)

-- ADJUST Y-OFFSET OF NON-UNIFORM SIZED CHARS
TextCandy.SetCharYOffset("SMALL", ":", 4 )
TextCandy.SetCharYOffset("SMALL", ",", 14)
TextCandy.SetCharYOffset("SMALL", ".", 15)
TextCandy.SetCharYOffset("SMALL", "'",-4 )
TextCandy.SetCharYOffset("SMALL", "-", 9)
TextCandy.SetCharYOffset("SMALL", "_", 14)

TextCandy.SetCharYOffset("SMALL2", ",", 14)
TextCandy.SetCharYOffset("SMALL2", ".", 15)

TextCandy.SetCharYOffset("SMOKY", ",", 22)
TextCandy.SetCharYOffset("SMOKY", ".", 22)
TextCandy.SetCharYOffset("SMOKY", "-", 10)

TextCandy.SetCharYOffset("FUR", ".", 35)
TextCandy.SetCharYOffset("LED", ".", 35)

TextCandy.SetCharYOffset("GLOSSY", ".", 35)


-- BACKGROUND IMAGES
local BG1  = display.newImage ("Images/background.png")
local BG2  = display.newImage ("Images/background.png")
local BG3  = display.newImage ("Images/background_overlay.png")

BG2.xScale = 1.25
BG2.yScale = 1.25
BG2.alpha  = .4
BG3.xScale = 1.5
BG3.yScale = 1.5
BG3.alpha  = .75

-- THIS IS THE MOVING BACKGROUND TEXT:
local BGText = TextCandy.CreateText({
	fontName 	= "SPACE", 						
	x		 	= screenW*.5,						
	y		 	= screenH*2,						
	text	 	= "TEXT CANDY TEXT CANDY ",	
	originX	 	= "CENTER",							
	originY	 	= "CENTER",							
	textFlow 	= "CENTER",	
	showOrigin 	= false,
	})

BGText:applyDeform({
	type			= TextCandy.DEFORM_CIRCLE,
	radius			= 140,
	autoStep 		= true,
	ignoreSpaces	= false,
	})

BGText.xScale   = 3.5
BGText.yScale   = 3.5
BGText.alpha    = 0.5
BGText.rotation = -20

-- THE BACKGROUND LOGO
local BG4  = display.newImage ("Images/background2.png")
transition.to   (BG4, { y = -screenH/2, time = 1000, transition = easing.inQuad , delay = 15000 } )


----------------------------------------------------------------


-- CREATE OUR TEXT (WE WILL RE-USE THIS ONE)
local MyText = TextCandy.CreateText({
	fontName 	= "SMALL2", 						
	x		 	= screenW*.5,						
	y		 	= screenH*.5,						
	text	 	= "TEXT CANDY IS AN EASY TO USE BUT VERY POWERFUL TEXT ENGINE TO CREATE AND ANIMATE ALL KIND OF TEXTS IN YOUR APP.",	
	originX	 	= "CENTER",							
	originY	 	= "CENTER",							
	textFlow 	= "CENTER",	
	wrapWidth	= 400, 								
	showOrigin 	= false,
	})


-- THE DIFFERENT (RANDOMLY APPLIED) TRANSITIONS WE USE
local InAnimations = {}
InAnimations[1] 	= { xScale = 4.0, yScale = 4.0, y = -screenH, time = 500, transition = easing.outQuad }
InAnimations[2] 	= { xScale = 0.1, yScale = 0.1, x = 0, y = 0, time = 750, transition = easing.outQuad }
InAnimations[3] 	= { y = screenH, rotation = 360, time = 750, transition = easing.outQuad }
InAnimations[4] 	= { y =-screenH, xScale = -1.0, time = 750, transition = easing.outQuad }
InAnimations[5] 	= { xScale = -4.0, yScale = 4.0, y = -screenH, time = 750, transition = easing.outQuad }
InAnimations[6] 	= { xScale = -4.0, yScale = 4.0, x = -screenH, time = 1000, transition = easing.outQuad }

local OutAnimations	= {}
OutAnimations[1] 	= { xScale = 4.0, yScale = 4.0, x = -screenW, y = screenH, time = 500, transition = easing.inQuad }
OutAnimations[2] 	= { y = screenH, rotation = 180, time = 750, transition = easing.inQuad }
OutAnimations[3] 	= { y = screenH, x = screenW, time = 750, transition = easing.inQuad }
OutAnimations[4] 	= { xScale = -4.0, yScale = 4.0, y = screenH, time = 750, transition = easing.inQuad }
OutAnimations[5] 	= { xScale = -4.0, yScale = 4.0, x = -screenW, time = 1000, transition = easing.inQuad }

local modes			= {"LEFT_RIGHT", "RIGHT_LEFT", "RANDOM", "ALL"}

-- OUR DEFAULT TRANSITION SETTINGS
local BaseTransition = 
	{
	hideCharsBefore 	= true,
	hideCharsAfter  	= true,
	startNow			= true,
	loop				= false,
	autoRemoveText  	= false,
	restartOnChange		= true,
	restoreOnComplete 	= true,
	-- IN TRANSITION
	inDelay				= 3000,
	inCharDelay			= 40,
	inMode   			= "LEFT_RIGHT",
	InSound   			= Snd_Beep,
	AnimateFrom			= {xScale = 1.25, yScale = 1.25, alpha = 0, time = 2000, transition = easing.outQuad},
	-- OUT TRANSITION
	outDelay			= 3000,
	outCharDelay		= 40,
	outMode   			= "LEFT_RIGHT",
	AnimateTo			= {xScale = 1.25, yScale = 1.25, alpha = 0, time = 2000, transition = easing.outQuad},
	}

-- APPLY THIS TRANSITION TO THE TEXT AND LET IT PLAY
MyText:applyInOutTransition( BaseTransition )



local Timer
local currScene = 0

Runtime:addEventListener("enterFrame", function()
	-- ANIMATE BACKGROUND IMAGES
	BGText.rotation = BGText.rotation - 0.3
	BG2.rotation 	= math.sin(system.getTimer()/1000) * 12
	BG3.rotation 	= BG2.rotation - 1

	-- LAST TRANSITION ENDED? CHANGE TEXT AND APPLY ANOTHER RANDOM TRANSITION
	if MyText:transitionActive() == false and Timer == nil then	
		
		-- WE REUSE OUR TRANSITION AND JUST APPLY NEW IN- OUT-ANIMATIONS TO IT:
		local mode1  = math.ceil(math.random()*#modes)
		local mode2  = math.ceil(math.random()*#modes)
		local trans1 = math.ceil(math.random()*#InAnimations)
		local trans2 = math.ceil(math.random()*#OutAnimations)

		BaseTransition.inDelay			= 0
		BaseTransition.AnimateFrom 		= InAnimations [trans1]
		BaseTransition.AnimateTo 		= OutAnimations[trans2]
		BaseTransition.inMode	   		= modes 	   [mode1]
		BaseTransition.outMode	   		= modes 	   [mode2]
		BaseTransition.startNow    		= false
		
		MyText:applyInOutTransition( BaseTransition )
		
		-- NEXT SCENE
		currScene = currScene + 1

		if currScene == 1 then
			MyText:changeFont ("SMALL")
			MyText:setText    ("CREATE ANY KIND OF STATIC OR ANIMATED TEXTS, MESSAGES, SCRORE DISPLAYS, TITLE SCREENS, BUTTONS AND MORE!",400)
		------------------------------------------------------------
		elseif currScene == 2 then
			MyText:changeFont ("SMOKY")
			MyText:setText("CREATE TEXTS USING BITMAP CHARSETS OR TRUE TYPE FONTS. THIS IS A BITMAP FONT, FOR EXAMPLE.")
		------------------------------------------------------------
		elseif currScene == 3 then
			MyText:changeFont ("FUR")
			MyText:setText("ANOTHER FANCY BITMAP FONT..!")
		------------------------------------------------------------
		elseif currScene == 4 then
			MyText:changeFont("LED")
			MyText:setText("...AND HERE IS ANOTHER ONE!")
		------------------------------------------------------------
		elseif currScene == 5 then
			MyText:changeFont("Floraless")
			MyText:setText("USE CUSTOM TRUE TYPE FONTS. THIS IS A TRUE TYPE FONT.")
		------------------------------------------------------------
		elseif currScene == 6 then
			MyText:addDropShadow(6,6,200)
			MyText:setText("APPLY DROP SHADOWS TO TRUE TYPE FONTS.")
		------------------------------------------------------------
		elseif currScene == 7 then
			MyText:addDropShadow()
			MyText:changeFont ("SMALL")
			MyText:setTextFlow("LEFT")
			MyText:setText("CHANGE THE TEXT FLOW DIRECTION AT ANY TIME. THIS TEXT IS LEFT-ALIGNED.")
		------------------------------------------------------------
		elseif currScene == 8 then
			MyText:setTextFlow("CENTER")
			MyText:setText("THIS IS A CENTERED TEXT. THE TEXT FLOW PROPERTY IS SET TO 'CENTER'.")
		------------------------------------------------------------
		elseif currScene == 9 then
			MyText:setTextFlow("RIGHT")
			MyText:setText("AND HERE IS A TEXT WITH THE TEXT FLOW PROPERTY SET TO 'RIGHT'. CHANGE ANY TEXT PROPERTY AT ANY TIME.")
		------------------------------------------------------------
		elseif currScene == 10 then
			MyText:setTextFlow("LEFT")
			MyText:setProperty("showOrigin", true)
			MyText:setText("YOU CAN CONTROL THE POSITION OF A TEXT'S ORIGIN TO POSITION TEXTS ACCURATELY. SEE THE LITTLE YELLOW CIRCLE IN THE CENTER? THIS IS THE TEXT'S ORIGIN.")
		------------------------------------------------------------
		elseif currScene == 11 then
			MyText:removeInOutTransition()
			MyText:changeFont ("SMOKY")
			MyText:setProperty("showOrigin", false)
			MyText:setText    ("APPLY COOL ANIMATION EFFECTS TO YOUR TEXTS!")
			MyText:applyAnimation(
				{
				startNow		= true,
				restartOnChange = true,
				charWise		= true,

				frequency 		= 150,
				rotationRange	= 15,
				xScaleRange		= 0.25,
				yScaleRange		= 0.25,
				xRange			= 4,
				yRange			= 6
				} )
			Timer = timer.performWithDelay(7000, function() timer.cancel(Timer); Timer = nil end )
		------------------------------------------------------------
		elseif currScene == 12 then
			MyText:removeInOutTransition()
			MyText:changeFont ("LED")
			MyText:setText("APPLY COOL ANIMATION EFFECTS TO YOUR TEXTS!")
			MyText:applyAnimation(
				{
				startNow		= true,
				restartOnChange = true,
				charWise		= true,

				frequency 		= 250,
				startAlpha		= 0.75,
				alphaRange		= 0.25,
				xScaleRange		= 0.25,
				yScaleRange		= 0.25,
				yRange			= 6,
				} )
			Timer = timer.performWithDelay(7000, function() timer.cancel(Timer); Timer = nil end )
		------------------------------------------------------------
		elseif currScene == 13 then
			MyText:removeAnimation()
			MyText:setOrigin  ("CENTER", "CENTER")
			MyText:setTextFlow("CENTER")
			MyText:changeFont ("SMALL")
			MyText:setText  ("POSITION, ROTATE, SCALE AND MOVE ALL TEXTS LIKE COMMON DISPLAY OBJECTS.")
			MyText.x 		= screenW * .5 
			MyText.y 		= screenH * .5
			MyText.rotation = -25
		------------------------------------------------------------
		elseif currScene == 14 then
			MyText.rotation    = 0
			MyText.lineSpacing = -2
			MyText:setText  ("APPLY WEIRD DEFORMATION EFFECTS TO YOUR TEXTS!")
			MyText:applyDeform({
				type	= TextCandy.DEFORM_SQUEEZE,
				min		= 0.0,
				max		= 3.0,
				mode	= "INNER",
				scaleX	= false,
				scaleY	= true,
			})
		------------------------------------------------------------
		elseif currScene == 15 then
			MyText.lineSpacing = 10
			MyText:setText  ("ANOTHER DEFORMATION EFFECT")
			MyText:applyDeform({
				type	= TextCandy.DEFORM_SQUEEZE,
				min		= 0.0,
				max		= 3.0,
				mode	= "OUTER",
				scaleX	= false,
				scaleY	= true,
			})
		------------------------------------------------------------
		elseif currScene == 16 then
			MyText.lineSpacing = -6
			MyText:setText  ("ANOTHER DEFORMATION EFFECT")
			MyText:applyDeform({
				type	= TextCandy.DEFORM_SQUEEZE,
				min		= 0.0,
				max		= 3.0,
				mode	= "RIGHT",
				scaleX	= false,
				scaleY	= true,
			})
		------------------------------------------------------------
		elseif currScene == 17 then
			MyText:changeFont("SMOKY")
			MyText:setText   ("YOU CAN CREATE WAVY TEXTS...")
			MyText:applyDeform({
				type 		= TextCandy.DEFORM_WAVE_Y,
				frequency 	= 50,
				amplitude	= 15,
			})
		------------------------------------------------------------
		elseif currScene == 18 then
			MyText:setText  ("OR ARCHED TEXTS!",0)
			MyText:applyDeform({
				type			= TextCandy.DEFORM_CIRCLE,
				radius			= 140,
				autoStep 		= false,
				ignoreSpaces	= false,
				angleStep		= 10,
			})
			MyText.rotation = -75
		------------------------------------------------------------
		elseif currScene == 19 then
			MyText.rotation = 0
			MyText:setText  ("CIRCULAR TEXTS - WHOOOOO...",0)
			MyText:applyDeform({
				type			= TextCandy.DEFORM_CIRCLE,
				radius			= 140,
				autoStep 		= true,
				ignoreSpaces	= false,
			})
		------------------------------------------------------------
		elseif currScene == 20 then
			MyText:changeFont("SMALL")
			MyText:setText   ("...OR EVEN WEIRD SPIRAL SHAPED TEXTS -WHATEVER YOU IMAGINE!",0)
			MyText:applyDeform({
				type			= TextCandy.DEFORM_CIRCLE,
				radius			= 140,
				radiusChange 	= -1.7,
				angleStep		= 10,
				autoStep 		= false,
				stepChange		= .15,
				ignoreSpaces	= false
			})
		------------------------------------------------------------
		elseif currScene == 21 then
			MyText:removeDeform()
			MyText:removeInOutTransition()
			MyText:changeFont("GLOSSY")
			MyText.x = 0
			MyText:setText("GENERATE AUTOMATIC HORIZONTAL SCROLLING TEXTS OF ANY LENGTH... ")
			MyText:startMarquee(15, 5, screenW)
			Timer = timer.performWithDelay(20000, function() timer.cancel(Timer); Timer = nil end )
		------------------------------------------------------------
		elseif currScene == 22 then
			MyText:removeInOutTransition()
			MyText:changeFont("SMALL")
			MyText:stopMarquee()
			MyText.x = screenW*.5
			MyText:setTextFlow("LEFT")
			MyText:setOrigin("CENTER", "CENTER")
			MyText:changeFont("SMALL")
			-- ADD A BACKGROUND GRAPHIC
			MyText:addBackground( display.newImage("Images/background_text.png"), 4,10, .75 )

			-- ADD SCROLLBAR
			MyText:addScrollbar({
				xOffset		= 20,
				scaleButton = true,
				autoHide	= true,
				startLine	= 1,
				linesToShow = 6,
				Button 		= display.newImage("Images/scrollbutton.png"), 
				Frame 		= display.newImage("Images/scrollbarframe.png"),
				ButtonTop	= display.newImage("Images/scrollbutton_top.png"), 
				ButtonBottom= display.newImage("Images/scrollbutton_bottom.png"), 
				FrameTop	= display.newImage("Images/scrollbarframe_top.png"),
				FrameBottom	= display.newImage("Images/scrollbarframe_bottom.png"),
				})
			MyText:setText("ATTACH AUTOMATIC, CUSTOMIZABLE SCROLLBARS TO YOUR TEXTS! SCROLLBARS ARE A GOOD WAY TO DISPLAY TEXTS OF ANY LENGTH. SCROLLBARS CAN BE ATTACHED AND REMOVED AT ANY TIME. ", 300)
			Timer = timer.performWithDelay(20000, function() timer.cancel(Timer); Timer = nil end )
		------------------------------------------------------------
		elseif currScene == 23 then
			MyText:removeBackground()
			MyText:removeScrollbar()
			MyText:setTextFlow("CENTER")
			MyText:setText("TEXT CANDY COMES WITH MANY BEAUTIFUL, READY TO USE BITMAP FONTS.")
			currScene = 0
		------------------------------------------------------------
		else
			MyText:changeFont("SMOKY")
			MyText:setText("THANKS FOR WATCHING!")
			currScene = 0
		end
	end -- END IF TRANSITION NOT ACTIVE
	
end )




